﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamGridCollectionViewTest
{
   /// <summary>
   /// Interaction logic for Window1.xaml
   /// </summary>
   public partial class Window1 : Window
   {
      public Window1()
      {
         InitializeComponent();

         // Setup the view for the XamDataPresenter
         ContactView1 = new ContactView(new Contacts());
         ContactView1.CurrentChanged += new EventHandler(ContactView1_CurrentChanged);
         ObjectDataProvider cv1Odb = (ObjectDataProvider)this.FindResource("ContactView1");
         cv1Odb.ObjectInstance = ContactView1;

         // Setup the view for the ListBox
         ContactView2 = new ContactView(new Contacts());
         ContactView2.CurrentChanged += new EventHandler(ContactView2_CurrentChanged);
         ObjectDataProvider cv2Odb = (ObjectDataProvider)this.FindResource("ContactView2");
         cv2Odb.ObjectInstance = ContactView2;

      }

      void ContactView1_CurrentChanged(object sender, EventArgs e)
      {
         MessageBox.Show("CurrentChanged event on XamDataPresenter view");
      }

      void ContactView2_CurrentChanged(object sender, EventArgs e)
      {
         MessageBox.Show("CurrentChanged event on ListBox view");
      }

      public ContactView ContactView1 { get; set; }
      public ContactView ContactView2 { get; set; }
   }

   /// <summary>
   /// 
   /// </summary>
   public class Contact
   {
      public string FirstName { get; set; }
      public string LastName { get; set; }
      public string PhoneNumber { get; set; }
   }

   /// <summary>
   /// 
   /// </summary>
   public class Contacts : List<Contact>
   {
      public Contacts()
      {
         this.Add(new Contact() { FirstName = "John", LastName = "Smith", PhoneNumber = "111-111-1111" });
         this.Add(new Contact() { FirstName = "Jane", LastName = "Doe", PhoneNumber = "222-222-222" });
         this.Add(new Contact() { FirstName = "Bill", LastName = "Gates", PhoneNumber = "333-333-3333" });
      }
   }

   /// <summary>
   /// 
   /// </summary>
   public class ContactView : ListCollectionView
   {
      public ContactView(Contacts contactList) : base(contactList)
      {

      }
   }
}
